package com.zhongzheng.modules.recruit.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.recruit.bo.RecruitInterviewLogAddBo;
import com.zhongzheng.modules.recruit.bo.RecruitInterviewLogQueryBo;
import com.zhongzheng.modules.recruit.bo.RecruitInterviewLogEditBo;
import com.zhongzheng.modules.recruit.domain.RecruitInterviewLog;
import com.zhongzheng.modules.recruit.mapper.RecruitInterviewLogMapper;
import com.zhongzheng.modules.recruit.vo.RecruitInterviewLogVo;
import com.zhongzheng.modules.recruit.service.IRecruitInterviewLogService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author ruoyi
 * @date 2021-08-25
 */
@Service
public class RecruitInterviewLogServiceImpl extends ServiceImpl<RecruitInterviewLogMapper, RecruitInterviewLog> implements IRecruitInterviewLogService {

    @Override
    public RecruitInterviewLogVo queryById(Long id){
        RecruitInterviewLog db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, RecruitInterviewLogVo.class);
    }

    @Override
    public List<RecruitInterviewLogVo> queryList(RecruitInterviewLogQueryBo bo) {
        LambdaQueryWrapper<RecruitInterviewLog> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getInterviewId() != null, RecruitInterviewLog::getInterviewId, bo.getInterviewId());
        lqw.eq(bo.getStatus() != null, RecruitInterviewLog::getStatus, bo.getStatus());
        lqw.eq(bo.getSysUserId() != null, RecruitInterviewLog::getSysUserId, bo.getSysUserId());
        lqw.eq(bo.getUserId() != null, RecruitInterviewLog::getUserId, bo.getUserId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<RecruitInterviewLogVo> entity2Vo(Collection<RecruitInterviewLog> collection) {
        List<RecruitInterviewLogVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, RecruitInterviewLogVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<RecruitInterviewLog> page = (Page<RecruitInterviewLog>)collection;
            Page<RecruitInterviewLogVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(RecruitInterviewLogAddBo bo) {
        RecruitInterviewLog add = BeanUtil.toBean(bo, RecruitInterviewLog.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(RecruitInterviewLogEditBo bo) {
        RecruitInterviewLog update = BeanUtil.toBean(bo, RecruitInterviewLog.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(RecruitInterviewLog entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }

}
